MWAWVec2< T > Class Template Reference documentation

Classes | Public Types | Public Member Functions | Protected Attributes | Friends | List of all members
MWAWVec2< T > Class Template Reference

small class which defines a vector with 2 elements More...

`#include <libmwaw_internal.hxx>`

## Classes
struct | PosSizeLtX
| internal struct used to create sorted map, sorted by X More...
struct | PosSizeLtY
| internal struct used to create sorted map, sorted by Y More...

## Public Types
typedef std::map< MWAWVec2< T >, T, struct PosSizeLtX > | MapX
| map of MWAWVec2 More...
typedef std::map< MWAWVec2< T >, T, struct PosSizeLtY > | MapY
| map of MWAWVec2 More...

## Public Member Functions
| MWAWVec2 (T xx=0, T yy=0)
| constructor More...
template<class U >
| MWAWVec2 (MWAWVec2< U > const &p)
| generic copy constructor More...
T | x () const
| first element More...
T | y () const
| second element More...
T | operator[] (int c) const
| operator[] More...
T & | operator[] (int c)
| operator[] More...
void | set (T xx, T yy)
| resets the two elements More...
void | setX (T xx)
| resets the first element More...
void | setY (T yy)
| resets the second element More...
void | add (T dx, T dy)
| increases the actuals values by dx and dy More...
MWAWVec2< T > & | operator+= (MWAWVec2< T > const &p)
| operator+= More...
MWAWVec2< T > & | operator-= (MWAWVec2< T > const &p)
| operator-= More...
template<class U >
MWAWVec2< T > & | operator*= (U scale)
| generic operator*= More...
bool | operator== (MWAWVec2< T > const &p) const
| comparison== More...
bool | operator!= (MWAWVec2< T > const &p) const
| comparison!= More...
bool | operator< (MWAWVec2< T > const &p) const
| comparison<: sort by y More...
int | cmp (MWAWVec2< T > const &p) const
| a comparison function: which first compares x then y More...
int | cmpY (MWAWVec2< T > const &p) const
| a comparison function: which first compares y then x More...

## Protected Attributes
T | m_x
| first element More...
T | m_y
| second element More...

## Friends
MWAWVec2< T > | operator+ (MWAWVec2< T > const &p1, MWAWVec2< T > const &p2)
| operator+ More...
MWAWVec2< T > | operator- (MWAWVec2< T > const &p1, MWAWVec2< T > const &p2)
| operator- More...
template<class U >
MWAWVec2< T > | operator* (U scale, MWAWVec2< T > const &p1)
| generic operator* More...
std::ostream & | operator<< (std::ostream &o, MWAWVec2< T > const &f)
| operator<<: prints data in form "XxY" More...

## Detailed Description

### template<class T>
class MWAWVec2< T >

small class which defines a vector with 2 elements

## Member Typedef Documentation

## ◆ MapX

template<class T>

MWAWVec2< T >::MapX

map of MWAWVec2

## ◆ MapY

template<class T>

MWAWVec2< T >::MapY

map of MWAWVec2

## Constructor & Destructor Documentation

## ◆ MWAWVec2() [1/2]

template<class T>

MWAWVec2< T >::MWAWVec2 | ( | T | xx = `0`,
|  | T | yy = `0`
| ) |  |
| inlineexplicit

constructor

## ◆ MWAWVec2() [2/2]

template<class T>
template<class U >

MWAWVec2< T >::MWAWVec2 | ( | MWAWVec2< U > const & | p | ) |
| inlineexplicit

generic copy constructor

## Member Function Documentation

## ◆ add()

template<class T>

void MWAWVec2< T >::add | ( | T | dx,
|  | T | dy
| ) |  |
| inline

increases the actuals values by dx and dy

Referenced by MWAWVec2< bool >::operator+=(), and MWAWVec2< bool >::operator-=().

## ◆ cmp()

template<class T>

int MWAWVec2< T >::cmp | ( | MWAWVec2< T > const & | p | ) | const
| inline

a comparison function: which first compares x then y

Referenced by MWAWGraphicShape::cmp(), MWAWGraphicStyle::Pattern::cmp(), MWAWGraphicStyle::cmp(), and MWAWVec2< T >::PosSizeLtX::operator()().

## ◆ cmpY()

template<class T>

int MWAWVec2< T >::cmpY | ( | MWAWVec2< T > const & | p | ) | const
| inline

a comparison function: which first compares y then x

Referenced by MWAWPictBitmapContainer< bool >::cmp(), MWAWPictBitmapContainerBool::cmp(), MWAWPosition::cmp(), MWAWVec2< bool >::operator!=(), MWAWVec2< T >::PosSizeLtY::operator()(), MWAWVec2< bool >::operator<(), and MWAWVec2< bool >::operator==().

## ◆ operator!=()

template<class T>

bool MWAWVec2< T >::operator!= | ( | MWAWVec2< T > const & | p | ) | const
| inline

comparison!=

## ◆ operator*=()

template<class T>
template<class U >

MWAWVec2<T>& MWAWVec2< T >::operator*= | ( | U | scale | ) |
| inline

generic operator*=

## ◆ operator+=()

template<class T>

MWAWVec2<T>& MWAWVec2< T >::operator+= | ( | MWAWVec2< T > const & | p | ) |
| inline

operator+=

## ◆ operator-=()

template<class T>

MWAWVec2<T>& MWAWVec2< T >::operator-= | ( | MWAWVec2< T > const & | p | ) |
| inline

operator-=

## ◆ operator<()

template<class T>

bool MWAWVec2< T >::operator< | ( | MWAWVec2< T > const & | p | ) | const
| inline

comparison<: sort by y

## ◆ operator==()

template<class T>

bool MWAWVec2< T >::operator== | ( | MWAWVec2< T > const & | p | ) | const
| inline

comparison==

## ◆ operator[]() [1/2]

template<class T>

T MWAWVec2< T >::operator[] | ( | int | c | ) | const
| inline

operator[]

## ◆ operator[]() [2/2]

template<class T>

T& MWAWVec2< T >::operator[] | ( | int | c | ) |
| inline

operator[]

## ◆ set()

template<class T>

void MWAWVec2< T >::set | ( | T | xx,
|  | T | yy
| ) |  |
| inline

resets the two elements

Referenced by libmwaw::PrinterRectResolution::read(), libmwaw_applepict1::OpCode::readPoint(), and MsWks4Zone::readPRNT().

## ◆ setX()

template<class T>

void MWAWVec2< T >::setX | ( | T | xx | ) |
| inline

resets the first element

Referenced by MsWks4Zone::readFRAM().

## ◆ setY()

template<class T>

void MWAWVec2< T >::setY | ( | T | yy | ) |
| inline

resets the second element

Referenced by MsWks4Zone::readFRAM().

## ◆ x()

template<class T>

T MWAWVec2< T >::x | ( |  | ) | const
| inline

first element

Referenced by MWAWTextListener::_handleFrameParameters(), MWAWPresentationListener::_handleFrameParameters(), MWAWGraphicListener::_handleFrameParameters(), MWAWSpreadsheetListener::_handleFrameParameters(), MWAWGraphicShape::addTo(), MWAWPictMac::checkOrGet(), WriterPlsParserInternal::WindowsInfo::dimensionInvalid(), MWAWPictData::get(), ApplePictParserInternal::Bitmap::get(), MacDraft5StyleManagerInternal::Pixmap::get(), ApplePictParserInternal::Pixmap::get(), MsWksGraph::getEntryPicture(), MsWksGraphInternal::Zone::getLocalBox(), MacWrtParserInternal::WindowsInfo::isEmpty(), MWAWGraphicListener::MWAWGraphicListener(), MWAWSpreadsheetListener::MWAWSpreadsheetListener(), HanMacWrdKGraphInternal::operator<<(), WriterPlsParserInternal::operator<<(), MWAWOLEParser::parse(), libmwaw::PrinterRect::read(), libmwaw_applepict1::Bitmap::read(), ApplePictParser::readBitmap(), ClarisDrawParser::readDocHeader(), ClarisWksDocument::readDocHeader(), PowerPoint3Parser::readDocInfo(), PowerPoint1Parser::readDocInfo(), MacWrtParser::readGraphic(), WriterPlsParser::readGraphic(), MsWksDocument::readGroupHeaderFooter(), ApplePictParser::readPixmap(), MacDraft5StyleManagerInternal::Pixmap::readPixmapData(), ApplePictParserInternal::Pixmap::readPixmapData(), MouseWrtParser::readPrintInfo(), SuperPaintParser::readPrintInfo(), MacDrawParser::readPrintInfo(), WingzParser::readPrintInfo(), MacWrtParser::readPrintInfo(), WriterPlsParser::readPrintInfo(), MacDrawProParser::readPrintInfo(), CricketDrawParser::readPrintInfo(), StyleParser::readPrintInfo(), MacDraftParser::readPrintInfo(), MacDraft5Parser::readPrintInfo(), ActaParser::readPrintInfo(), LightWayTxtParser::readPrintInfo(), ClarisDrawParser::readPrintInfo(), MindWrtParser::readPrintInfo(), PowerPoint1Parser::readPrintInfo(), BeagleWksDBParser::readPrintInfo(), BeagleWksBMParser::readPrintInfo(), NisusWrtParser::readPrintInfo(), BeagleWksParser::readPrintInfo(), BeagleWksSSParser::readPrintInfo(), MoreParser::readPrintInfo(), PowerPoint3Parser::readPrintInfo(), FullWrtParser::readPrintInfo(), GreatWksDocument::readPrintInfo(), MsWrdParser::readPrintInfo(), BeagleWksDRParser::readPrintInfo(), WriteNowParser::readPrintInfo(), MsWksDocument::readPrintInfo(), MacWrtProParser::readPrintInfo(), RagTimeParser::readPrintInfo(), ClarisWksDocument::readPrintInfo(), HanMacWrdJParser::readPrintInfo(), MarinerWrtParser::readPrintInfo(), HanMacWrdKParser::readPrintInfo(), MsWks4Zone::readPRNT(), WriteNowText::readTokenV2(), MWAWBox2< int >::resizeFromCenter(), libmwaw_applepict1::Bitmap::saveBitmap(), FullWrtGraph::sendGraphic(), WriteNowParser::sendPicture(), and MacWrtProParser::sendPicture().

## ◆ y()

template<class T>

T MWAWVec2< T >::y | ( |  | ) | const
| inline

second element

Referenced by MWAWTextListener::_handleFrameParameters(), MWAWPresentationListener::_handleFrameParameters(), MWAWGraphicListener::_handleFrameParameters(), MWAWSpreadsheetListener::_handleFrameParameters(), MWAWGraphicShape::addTo(), MWAWPictMac::checkOrGet(), WriterPlsParserInternal::WindowsInfo::dimensionInvalid(), MWAWPictData::get(), MsWksGraph::getEntryPicture(), MsWksGraphInternal::Zone::getLocalBox(), MWAWGraphicListener::MWAWGraphicListener(), MWAWSpreadsheetListener::MWAWSpreadsheetListener(), HanMacWrdKGraphInternal::operator<<(), WriterPlsParserInternal::operator<<(), MWAWOLEParser::parse(), libmwaw::PrinterRect::read(), libmwaw_applepict1::Bitmap::read(), ApplePictParser::readBitmap(), ApplePictParserInternal::Bitmap::readBitmapData(), libmwaw_applepict1::Bitmap::readBitmapData(), ClarisDrawParser::readDocHeader(), ClarisWksDocument::readDocHeader(), PowerPoint3Parser::readDocInfo(), PowerPoint1Parser::readDocInfo(), MacWrtParser::readGraphic(), WriterPlsParser::readGraphic(), MsWksDocument::readGroupHeaderFooter(), ApplePictParser::readPixmap(), MacDraft5StyleManagerInternal::Pixmap::readPixmapData(), ApplePictParserInternal::Pixmap::readPixmapData(), MouseWrtParser::readPrintInfo(), MacDrawParser::readPrintInfo(), SuperPaintParser::readPrintInfo(), WingzParser::readPrintInfo(), MacWrtParser::readPrintInfo(), WriterPlsParser::readPrintInfo(), MacDrawProParser::readPrintInfo(), CricketDrawParser::readPrintInfo(), StyleParser::readPrintInfo(), MacDraftParser::readPrintInfo(), MacDraft5Parser::readPrintInfo(), ActaParser::readPrintInfo(), LightWayTxtParser::readPrintInfo(), ClarisDrawParser::readPrintInfo(), MindWrtParser::readPrintInfo(), PowerPoint1Parser::readPrintInfo(), BeagleWksDBParser::readPrintInfo(), BeagleWksBMParser::readPrintInfo(), BeagleWksParser::readPrintInfo(), NisusWrtParser::readPrintInfo(), BeagleWksSSParser::readPrintInfo(), MoreParser::readPrintInfo(), PowerPoint3Parser::readPrintInfo(), FullWrtParser::readPrintInfo(), GreatWksDocument::readPrintInfo(), MsWrdParser::readPrintInfo(), BeagleWksDRParser::readPrintInfo(), WriteNowParser::readPrintInfo(), MsWksDocument::readPrintInfo(), MacWrtProParser::readPrintInfo(), RagTimeParser::readPrintInfo(), HanMacWrdJParser::readPrintInfo(), ClarisWksDocument::readPrintInfo(), MarinerWrtParser::readPrintInfo(), HanMacWrdKParser::readPrintInfo(), MsWks4Zone::readPRNT(), WriteNowText::readTokenV2(), MWAWBox2< int >::resizeFromCenter(), FullWrtGraph::sendGraphic(), WriteNowParser::sendPicture(), and MacWrtProParser::sendPicture().

## Friends And Related Function Documentation

## ◆ operator*

template<class T>
template<class U >

MWAWVec2<T> operator* | ( | U | scale,
|  | MWAWVec2< T > const & | p1
| ) |  |
| friend

generic operator*

## ◆ operator+

template<class T>

MWAWVec2<T> operator+ | ( | MWAWVec2< T > const & | p1,
|  | MWAWVec2< T > const & | p2
| ) |  |
| friend

operator+

## ◆ operator-

template<class T>

MWAWVec2<T> operator- | ( | MWAWVec2< T > const & | p1,
|  | MWAWVec2< T > const & | p2
| ) |  |
| friend

operator-

## ◆ operator<<

template<class T>

std::ostream& operator<< | ( | std::ostream & | o,
|  | MWAWVec2< T > const & | f
| ) |  |
| friend

operator<<: prints data in form "XxY"

## Member Data Documentation

## ◆ m_x

template<class T>

T MWAWVec2< T >::m_x
| protected

first element

Referenced by MWAWVec2< bool >::add(), MWAWVec2< bool >::cmp(), MWAWVec2< bool >::cmpY(), MWAWVec2< bool >::operator*=(), MWAWVec2< bool >::operator+=(), MWAWVec2< bool >::operator-=(), MWAWVec2< bool >::operator[](), MWAWVec2< bool >::set(), MWAWVec2< bool >::setX(), and MWAWVec2< bool >::x().

## ◆ m_y

template<class T>

T MWAWVec2< T >::m_y
| protected

second element

Referenced by MWAWVec2< bool >::add(), MWAWVec2< bool >::cmp(), MWAWVec2< bool >::cmpY(), MWAWVec2< bool >::operator*=(), MWAWVec2< bool >::operator+=(), MWAWVec2< bool >::operator-=(), MWAWVec2< bool >::operator[](), MWAWVec2< bool >::set(), MWAWVec2< bool >::setY(), and MWAWVec2< bool >::y().

The documentation for this class was generated from the following file:

- libmwaw_internal.hxx